import { Middleware, MiddlewarePayload, MiddlewareNext } from '@amplitude/types';
export declare class MiddlewareRunner {
    private readonly _middlewares;
    /**
     * Add a @middleware to the chain.
     *
     * The provided middleware must call next(payload) for the chain to continue.
     * Otherwise any following middleware and next method will not be called.
     *
     * @param middleware A Middleware function
     */
    add(middleware: Middleware): void;
    /**
     * Runs the middleware chain with the given payload.
     *
     * @param payload The payload data for the middleware to receive
     * @param next The function to call after all middleware completes. Only runs if next(payload) is called by all middlewares.
     */
    run(payload: MiddlewarePayload, next: MiddlewareNext): void;
}
//# sourceMappingURL=middlewareRunner.d.ts.map